
import com.atlassian.jira.issue.customfields.searchers.transformer.CustomFieldInputHelper;
import com.atlassian.jira.issue.customfields.statistics.CustomFieldStattable;
import com.atlassian.jira.issue.fields.CustomField;
import com.atlassian.jira.issue.search.LuceneFieldSorter;
import com.atlassian.jira.issue.statistics.StatisticsMapper;
import com.atlassian.jira.jql.operand.JqlOperandResolver;
import com.atlassian.jira.security.JiraAuthenticationContext;
import com.atlassian.jira.web.FieldVisibilityManager;

public class ExactTextSearcher extends com.atlassian.jira.issue.customfields.searchers.ExactTextSearcher implements CustomFieldStattable
{
    private CustomFieldInputHelper customFieldInputHelper;
        private JiraAuthenticationContext jiraAuthenticationContext;

        public ExactTextSearcher(JqlOperandResolver jqlOperandResolver, CustomFieldInputHelper customFieldInputHelper,
                FieldVisibilityManager fieldVisibilityManager, JiraAuthenticationContext jiraAuthenticationContext) {
            super(jqlOperandResolver, customFieldInputHelper, fieldVisibilityManager);

            this.customFieldInputHelper = customFieldInputHelper;
            this.jiraAuthenticationContext = jiraAuthenticationContext;
        }

    @SuppressWarnings("rawtypes")
	public LuceneFieldSorter getSorter(CustomField customField) {
		return new TextFieldSorter(customField.getId());
	}

    @SuppressWarnings("rawtypes")
	@Override
    public StatisticsMapper getStatisticsMapper(CustomField custom_field) {
		return new TextStatisticsMapper(custom_field, customFieldInputHelper, jiraAuthenticationContext);
	}
}
